<?php
/*
Plugin Name: Tayon.ai Chatbot Widget Installer
Plugin URI: https://help.tayon.ai/wordpress
Description: Easily install the Tayon.ai widgets for lead captura and chatbot support in your Wordpress website pages.
Author: Tayon.ai
Author URI: https://tayon.ai
Text Domain: tayon-ai-chat-widget
Version: 1.0.3
*/

if (!defined('ABSPATH')) {
    exit;
}
require_once('config/index.php');

$varTayonUID = get_option(TAYON_AI_DATA_TOKEN);
if ($varTayonUID) {
    add_shortcode('TayonWidget', 'wp_TayorAiAddShortCode');
}


add_action("admin_menu", "addMenu");
function addMenu()
{
    add_menu_page("Tayon Widgets", "Tayon Widgets", 4, "tayonai-options", "TayonMainFunction", plugins_url("tayon-ai-chat-widget/images/robotfavicon.svg"));
}

function TayonMainFunction()
{

    $varTayonToken = get_option(TAYON_AI_DATA_TOKEN);

?>
    <div id="tayonDivId" class="wrap">
        <h1>Welcome to Tayon Widget Installer</h1>
        <?php if ($varTayonToken) {

            TayonShortCode();
        } else {
            getPageContent();
        }
        ?>
    </div>
<?php
    die();
    exit;
}

function TayonShortCode()
{
    $varTayonOTKEN = get_option(TAYON_AI_DATA_TOKEN);
    $varTayonAccData = get_option(TAYON_AI_ACC_DATA);
    $varTayonAccConfig = get_option(TAYON_AI_CONFIG_DATA);

    $TayonD = json_decode($varTayonAccData);

    $configData = json_decode($varTayonAccConfig);
    // var_dump($configData->widget_selected);

?>
    <h2>Welcome <?php echo $TayonD->User->name; ?>, </h2>
    <table class="form-table" role="presentation">
        <tbody>
            <tr class="user-first-name-wrap">
                <th><label for="tayon_acc_shortcode">Please select your widget to get the Installation Shortcode</label></th>
            </tr>
            <tr class="user-last-name-wrap">
                <td style="padding:0px;">
                    <select name="tayon_widgets" id="tayon_widgets" <?php if (isset($configData->widget_selected)) {
                                                                        echo 'disabled';
                                                                    } ?> class="regular-text">
                        <?php
                        if (count($TayonD->Widgets) > 0) {
                            $selected = '';
                            foreach ($TayonD->Widgets as $KeyTW => $ValTW) {
                                if (isset($configData->widget_selected) and $configData->widget_selected == $ValTW->wid) {
                                    $selected = 'selected';
                                } else {
                                    $selected = '';
                                }
                                echo '<option ' . $selected . ' value="' . $ValTW->wid . '">' . $ValTW->wname . '</option>';
                            }
                        } ?>
                    </select>

                    <button <?php if (isset($configData)) {
                                echo 'style="display:none;"';
                            } ?> type="button" name="select_widget" id="select_widget">Select</button>
                    <button <?php if (!isset($configData) and !$configData->widget_selected) {
                                echo 'style="display:none;"';
                            } ?> type="button" name="change_widget" id="change_widget">Change</button>
                </td>
            </tr>
        </tbody>
    </table>
    <div id="shortCodeDisp"></div>
    <br><br><br>

    <div class="showing_check" style="display:none;">
        <label>Show on all pages</label>
        <input type="checkbox" value="yes" name="show_all" <?php if (isset($configData) and $configData->show_all_page == 'yes') {
                                                                echo 'checked';
                                                            } ?> id="show_all" />
    </div>
    <br>
    <div class="showing_check" style="display:none;">
        <label>Enable or Disable</label>
        <input type="radio" name="enable_disable" <?php if ((isset($configData->widget_status) and $configData->widget_status == 'enable') or !isset($configData)) { ?> checked <?php } ?> id="enable" value="enable" />Enable
        &nbsp; &nbsp; &nbsp; &nbsp;
        <input type="radio" name="enable_disable" id="disable" <?php if (isset($configData->widget_status) and $configData->widget_status == 'disable') { ?> checked <?php } ?> value="disable" />Disable
    </div>

    <p>To refresh the available widgets, please disconnect from your Tayon account and connect again.</p>
    <p>To disconnect from your Tayon account, please use this button <input type="button" name="disconnect_tayon" id="disconnect_tayon" class="button button-primary" value="Disconnect" /></p>

    <script>
        jQuery(document).ready(function() {
            jQuery("#disconnect_tayon").click(function() {
                jQuery.ajax({
                    url: "admin-ajax.php",
                    method: 'POST',
                    data: {
                        'action': 'Tayon_disconnectTayonAcc'
                    },
                    success: function(Res) {
                        if (Res == 'disconnected') {
                            location.reload();
                        }
                    }
                });
            });


            jQuery("#change_widget").click(function() {
                jQuery('#tayon_widgets').prop("disabled", false);
                jQuery("#change_widget").hide();
                jQuery("#select_widget").show();
            });


            jQuery("#select_widget").click(function() {
                UpdateConfigData();
            });

            jQuery("#show_all").change(function() {
                UpdateConfigData();

            });

            jQuery("input[name='enable_disable']").click(function() {
                UpdateConfigData();
            });

            <?php
            if (isset($configData)) { ?>
                jQuery(".showing_check").show();
                jQuery("#shortCodeDisp").html('<p>Shortcode for use in the page editor:<br /><code>[TayonWidget id=<?php echo $configData->widget_selected; ?>]</code></p>' +
                    '<p>Shortcode for use directly on the PHP code:<br /><code> do_shortcode(\'[TayonWidget id=<?php echo $configData->widget_selected; ?>]\'); </code></p>');

            <?php } ?>

        });

        function UpdateConfigData() {
            jQuery.ajax({
                url: "admin-ajax.php",
                method: 'POST',
                data: {
                    'action': 'Tayon_upDateConfigData',
                    'widget_selected': jQuery('#tayon_widgets option:selected').val(),
                    'widget_status': jQuery("input[name='enable_disable']:checked").val(),
                    'show_all_page': (jQuery("#show_all").prop('checked') == true) ? 'yes' : 'no'
                },
                success: function(Res) {

                    jQuery("#shortCodeDisp").html('<p>Shortcode for use in the page editor:<br /><code>[TayonWidget id=' + jQuery('#tayon_widgets option:selected').val() + ']</code></p>' +
                        '<p>Shortcode for use directly on the PHP code:<br /><code> do_shortcode(\'[TayonWidget id=' + jQuery('#tayon_widgets option:selected').val() + ']\'); </code></p>');

                    jQuery('#tayon_widgets').prop("disabled", true);
                    jQuery(".showing_check").show();
                    jQuery('#select_widget').hide();
                    jQuery('#change_widget').show();

                }
            });
        }
    </script>

<?php
}



function getPageContent()
{  ?>
    <table class="form-table" role="presentation">
        <tbody>
            <tr class="user-first-name-wrap">
                <th><label for="tayon_acc_uid">Provide your Tayon Integration Key</label></th>
            </tr>
            <tr class="user-last-name-wrap">
                <td style="padding:0px;">
                    <input type="text" <?php if ($varTayonUID) {
                                            echo 'readonly';
                                        } ?> name="tayon_acc_uid" id="tayon_acc_uid" class="regular-text">
                    <span class="description" style="color:red;" id="tayon_error_message"></span>
                </td>
            </tr>
            <tr class="user-last-name-wrap" id="tayon_response_error" style="display:none;">
                <td style="padding:0px;color: red;" id="tayon_response_error_body">
                    Error: this Integration Key is invalid or inactive.
                </td>
            </tr>
            <tr class="user-last-name-wrap">
                <td style="padding:0px;">
                    Learn how to get your Tayon Integration Key <a target="_blank" href="https://help.tayon.ai#integration-key">here</a>
                </td>
            </tr>
            <tr class="user-last-name-wrap">
                <td colspan="1" style="text-align: left;padding:15px 0px;"><input type="button" name="submit" id="tayon_submit" class="button button-primary" value="Connect to your Tayon Account"></td>
            </tr>
        </tbody>
    </table>
    <p><strong>Don't have a Tayon account yet? Create your free account <a href="https://app.tayon.ai/register-try" target="_blank">here</a></strong></p>
    <script>
        jQuery(document).ready(function() {
            jQuery("#tayon_submit").click(function() {

                if (jQuery("#tayon_acc_uid").val() == '') {
                    jQuery('#tayon_error_message').html('The Integration Key is required');
                } else {
                    jQuery('#tayon_error_message').html('');
                    jQuery.ajax({
                        url: "<?php echo TAYON_API_URL; ?>/getWid/" + jQuery("#tayon_acc_uid").val(),
                        method: 'GET',
                        success: function(ResponseData) {
                            if (ResponseData.code == 1) {
                                jQuery.ajax({
                                    url: "admin-ajax.php",
                                    method: 'POST',
                                    data: {
                                        'action': 'Tayon_upDateTayonData',
                                        'TayonAI_Data': ResponseData.TayonData,
                                        'TayonAI_Token': jQuery("#tayon_acc_uid").val(),
                                    },
                                    success: function(Res) {
                                        if (Res == 'updated') {
                                            location.reload();
                                        }
                                    }

                                });
                            }
                            if (ResponseData.code == 2) {

                                //jQuery('#tayon_response_error_body').html(ResponseData.message);
                                jQuery('#tayon_response_error').show();
                            }
                        }
                    });
                }

            });
        });
    </script>
<?php }


add_action('wp_ajax_Tayon_upDateTayonData', 'Tayon_upDateTayonData');

add_action('wp_ajax_Tayon_upDateConfigData', 'Tayon_upDateConfigData');

function Tayon_upDateTayonData()
{
    update_option(TAYON_AI_ACC_DATA, json_encode($_POST['TayonAI_Data']));
    update_option(TAYON_AI_DATA_TOKEN, $_POST['TayonAI_Token']);
    echo 'updated';
    exit;
}

function Tayon_upDateConfigData($attr)
{

    unset($_POST['action']);
    update_option(TAYON_AI_CONFIG_DATA, json_encode($_POST));
    echo 'config data updated';
    exit;
}

function wp_TayorAiAddShortCode($attr)
{

    $varTayonWID = get_option(TAYON_AI_DATA_TOKEN);

    return "<script src='" . TAYON_CHAT_URL . "/widget/" . $attr['id'] . "/twidget.js'></script>";
    exit;
}

add_action('wp_ajax_Tayon_disconnectTayonAcc', 'disconnectTayonAcc');

function disconnectTayonAcc()
{

    delete_option(TAYON_AI_DATA_TOKEN);
    delete_option(TAYON_AI_ACC_DATA);
    delete_option(TAYON_AI_CONFIG_DATA);
    remove_shortcode('TaylorAI');
    echo 'disconnected';
    die();
    exit;
}

$varTayonConfigData = get_option(TAYON_AI_CONFIG_DATA);

if ($varTayonConfigData) {
    $TayonConfigData = json_decode($varTayonConfigData);

    if ($TayonConfigData->widget_status == 'enable' and $TayonConfigData->show_all_page == 'yes') {

        add_action('wp_footer', 'TayonShowAllPage', 5);
    }
}

function TayonShowAllPage()
{
    $varTayonConfigData = get_option(TAYON_AI_CONFIG_DATA);
    $TayonConfigData = json_decode($varTayonConfigData);

    if (isset($TayonConfigData) and $TayonConfigData->widget_status == 'enable') {
        echo "<script src='" . TAYON_CHAT_URL . "/widget/" . $TayonConfigData->widget_selected . "/twidget.js'></script>";
    }
    exit;
}
